import { LocationQueryValue } from 'vue-router';

declare function ArrayParam<TParam>(elementConfig: ParamSerializationConfig<TParam>): ParamSerializationConfig<NonNullable<TParam>[] | null>;

declare const BooleanParam: ParamSerializationConfig<boolean | null>;

declare const DateParam: ParamSerializationConfig<Date | null>;

declare const NumberParam: ParamSerializationConfig<number | null>;

declare function ObjectParam<TObject>(): ParamSerializationConfig<TObject | null>;

declare const StringParam: ParamSerializationConfig<string | null>;

type ParamSerializationConfig<TParam> = {
    serialize: (value: TParam | null) => LocationQueryValue | LocationQueryValue[];
    deserialize: (value: LocationQueryValue | LocationQueryValue[]) => TParam;
};

export { ArrayParam, BooleanParam, DateParam, NumberParam, ObjectParam, type ParamSerializationConfig, StringParam };
