import { ParamSerializationConfig } from './converters/index.js';
export { ArrayParam, BooleanParam, DateParam, NumberParam, ObjectParam, StringParam } from './converters/index.js';
import { Ref, Plugin } from 'vue';
import 'vue-router';

declare function useQueryParam<TParam>(name: string, { serialize, deserialize }: ParamSerializationConfig<TParam>): Ref<TParam>;

declare function withDefault<TParam>({ serialize, deserialize }: ParamSerializationConfig<TParam>, defaultValue: NonNullable<TParam>): ParamSerializationConfig<NonNullable<TParam>>;

type UseQueryParamPluginOptions = {
    debounceDelay?: number;
};
declare const useQueryParamPlugin: Plugin<UseQueryParamPluginOptions>;

export { ParamSerializationConfig, useQueryParamPlugin as default, useQueryParam, withDefault };
